package com.shiny.keyboard.ui

import android.annotation.SuppressLint
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.util.Log
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.isVisible
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.integration.webp.decoder.WebpDrawable
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.Target
import com.shiny.keyboard.MyApplication
import com.shiny.keyboard.R
import com.shiny.keyboard.ad.AdManager
import com.shiny.keyboard.database.DbHelper
import com.shiny.keyboard.frag.DialogActive
import com.shiny.keyboard.helper.DealZip
import com.shiny.keyboard.helper.SkinStore
import com.shiny.keyboard.helper.Utils
import com.shiny.keyboard.mylistener.OnItemClickListener
import com.shiny.keyboard.mylistener.SetThemesListener
import kotlinx.coroutines.launch
import java.io.File


class SetThemeActivity : AppCompatActivity() {
    companion object {
        @JvmField
        var DISPLAY_URL_KEY: String = "display_url_key"

        @JvmField
        val ZIP_URL_KEY = "zip_url_key"


        @JvmField
        val NAME_KEY = "name_key"

        @JvmField
        val GIF_KEY = "gif_key"

        @JvmField
        val THUMB_KEY = "thumb_key"

        @JvmField
        val SOURCE_KEY = "data_key"
    }

    private var dialog: DialogActive? = null
    private lateinit var displayUrl: String
    private lateinit var gifUrl: String
    private lateinit var zipUrl: String
    private lateinit var name: String
    private lateinit var applyBtn: LinearLayout
    private lateinit var imgData: ImageView
    private lateinit var imgBack: ImageView
    private lateinit var textName: TextView

    private lateinit var recommendedRecycler: RecyclerView
//    private lateinit var viewAllLayout: LinearLayout

    private lateinit var loadingLayout: FrameLayout

    private lateinit var unzipPath: String

    private lateinit var tvDownload: TextView
    private lateinit var imDownload: ImageView

    private lateinit var thumb: String

    private lateinit var imgLike: ImageView

    private lateinit var data: com.shiny.keyboard.bean.ChildData

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.act_set_theme)
        Utils.initFullScreen(this, false)
        AdManager.loadAllAd()
        findViewId()
        getExtraData()
        displayData()
        setApply()
        onClick()

        AdManager.showTopOn(this@SetThemeActivity) {

        }
    }


    private fun getExtraData() {
        data = intent.getSerializableExtra(SOURCE_KEY) as com.shiny.keyboard.bean.ChildData

        displayUrl = data.imgPath
//        displayUrl = intent.getStringExtra(DISPLAY_URL_KEY).toString()

        zipUrl = data.zipPath
//        zipUrl = intent.getStringExtra(ZIP_URL_KEY).toString()


        name = data.titleName
//        name = intent.getStringExtra(NAME_KEY).toString()


        gifUrl = data.imgGif
//        gifUrl = intent.getStringExtra(GIF_KEY).toString()

        data.thumbGif?.let {
            thumb = it
        }
        data.thumbUrl?.let {
            thumb = it
        }
//        thumb = intent.getStringExtra(THUMB_KEY).toString()

        val serviceZipName = DealZip.getServiceZipName(zipUrl)
        Log.d(MyApplication.TAG, "--------serviceZipName=$serviceZipName")
        unzipPath = DealZip.getUnzipPath(serviceZipName)


        lifecycleScope.launch {
            DbHelper.getIsLike(name) {
                imgLike.isSelected = it
            }
        }

        if (File(unzipPath).exists()) {
            imDownload.isVisible = false
            tvDownload.text = getString(R.string.apply)
        } else {
            imDownload.isVisible = true
            tvDownload.text = getString(R.string.download_apply)
        }

    }

    private fun findViewId() {
        applyBtn = findViewById(R.id.layoutDownloadApply)
        imgData = findViewById(R.id.image_data)
        imgBack = findViewById(R.id.back)
        textName = findViewById(R.id.textview_data_name)
        recommendedRecycler = findViewById(R.id.recommended_recycler)
//        viewAllLayout = findViewById(R.id.layout_view_all)

        imgLike = findViewById(R.id.im_like)
        loadingLayout = findViewById(R.id.loading)
        imDownload = findViewById(R.id.im_download)
        tvDownload = findViewById(R.id.tv_download)
    }

    private fun displayData() {
        textName.text = name
        if (gifUrl.isNotEmpty()) {
            loadImgGif()
        } else {
            Glide.with(this)
                .load(displayUrl)
                .placeholder(R.drawable.img_placeholder)
                .thumbnail(Glide.with(this).load(thumb))
                .into(imgData)
        }
    }


    private fun onClick() {
        imgBack.setOnClickListener {

            AdManager.showTopOn(this@SetThemeActivity) {
                finish()
            }

        }

        imgLike.setOnClickListener {

            AdManager.showTopOn(this@SetThemeActivity) {
                imgLike.isSelected = !imgLike.isSelected

                lifecycleScope.launch {
                    if (imgLike.isSelected) {
                        DbHelper.addLike(data)
                    } else {
                        DbHelper.removeLike(data)
                    }
                }
            }

        }
        val forYouList = MyApplication.list.filter {
            it.parentName == getString(R.string.recommend_name)

        }

        recommendedRecycler.run {
            adapter = com.shiny.keyboard.recycler.AdapterRecommend(
                this@SetThemeActivity
            ).apply {
                val shuffled = forYouList[0].keyboardList.shuffled()
                setForYouList(shuffled.subList(0, 8))
            }.apply {
                setClickAction(object : OnItemClickListener {
                    override fun onItemClick() {
                        finish()
                    }

                })
            }

            layoutManager = GridLayoutManager(this@SetThemeActivity, 2)

        }

    }

    @SuppressLint("CheckResult")
    private fun loadImgGif() {
        Glide.with(this)
            .load(gifUrl)
            .placeholder(R.drawable.img_placeholder)
            .thumbnail(Glide.with(this).load(thumb))
            .addListener(object : RequestListener<Drawable> {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any?,
                    target: Target<Drawable>,
                    isFirstResource: Boolean
                ): Boolean {

                    return false
                }

                override fun onResourceReady(
                    resource: Drawable,
                    model: Any,
                    target: Target<Drawable>?,
                    dataSource: DataSource,
                    isFirstResource: Boolean
                ): Boolean {
                    if (resource is WebpDrawable) {
                        resource.loopCount = WebpDrawable.LOOP_FOREVER
                    }

                    return false
                }

            }).into(imgData)
    }

    private fun setApply() {
        applyBtn.setOnClickListener {
            AdManager.showTopOn(this@SetThemeActivity) {
                val checkEnable = Utils.checkEnable(this)
                val checkSetDefault = Utils.checkSetDefault(this)
                if (!checkEnable || !checkSetDefault) {
                    showDialog()
                    return@showTopOn
                }
                startDown()
            }


        }
    }

    private fun showDialog() {
        dialog = dialog ?: DialogActive {
            startDown()
        }
        dialog?.show(supportFragmentManager, "")
    }

    private fun startDown() {
        loadingLayout.isVisible = true
        applyBtn.isEnabled = false

        val file = File(unzipPath)
        if (file.exists()) {
            val findFirstDirectory = DealZip.findFirstDirectory(file)

            apply("${findFirstDirectory}/")
            applyBtn.isEnabled = true
            loadingLayout.isVisible = false
        } else {
            DealZip.startDownloadZip(zipUrl, object :
                SetThemesListener {
                override fun OnApplySkinListener(fileList: List<File?>?) {
                    runOnUiThread {
                        applyBtn.isEnabled = true
                        loadingLayout.isVisible = false
                    }
                    if (fileList.isNullOrEmpty()) {
                        runOnUiThread {
                            Toast.makeText(
                                this@SetThemeActivity,
                                getString(R.string.download_fail),
                                Toast.LENGTH_SHORT
                            ).show()
                        }
                    } else {
//                        lifecycleScope.launch {
//                            DbHelper.addDownload(data)
//                        }
                        if (file.exists()) {
                            val findFirstDirectory = DealZip.findFirstDirectory(file)
                            Log.d(
                                MyApplication.TAG,
                                "----apply------------it=$findFirstDirectory"
                            )
                            runOnUiThread {
                                apply("${findFirstDirectory}/")

                            }
                        }
                    }


                }

            })
        }

    }

    private fun apply(path: String) {
        var skinParentPath = path
        if (path.contains("res")) {
            skinParentPath = path.substringBeforeLast("res")
        }


        SkinStore.updateSkinPath(skinParentPath)
        Toast.makeText(
            this@SetThemeActivity,
            getString(R.string.theme_application_successful),
            Toast.LENGTH_SHORT
        ).show()
        startActivity(Intent(this, com.shiny.keyboard.ui.OkActivity::class.java).apply {
            putExtra(com.shiny.keyboard.ui.OkActivity.key_name, name)
        })
        finish()
    }


}